/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * Development of this software was sponsored by the Office of Biological  *
 * and Environmental Research of the U.S. Department of Energy's Office    *
 * of Science.                                                             *
 *                                                                         *
 * Copyright 2011 UChicago Argonne, LLC.                                   *
 *                                                                         *
 * Licensed under the Apache License, Version 2.0 (the "License"); you     *
 * may not use this file except in compliance with the License.  You may   *
 * obtain a copy of the License at                                         * 
 *                                                                         *
 *   http://www.apache.org/licenses/LICENSE-2.0                            *
 *                                                                         *
 * Unless required by applicable law or agreed to in writing, software     *
 * distributed under the License is distributed on an "AS IS" BASIS,       *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or         *
 * implied.  See the License for the specific language governing           *
 * permissions and limitations under the License.                          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#include "moab_tag_reduce.hpp"

/*
void algorithm::util::dim_reduce(std::vector<pargal::util::moab_tag_chunk> &red_chunks, pargal::pcvar &var, algorithm::util::pargal_red_op op, const size_t odim, pargal::util::moab_red_chunk_counter &counter)
{
	dim_reduce_comm red_comm(var, odim);
	if(red_comm != MPI_COMM_NULL){
		// We need to add up the counters
		int rank;
		MPI_Comm_rank(red_comm, &rank);
		for(util:moab_tag_red_chunk_counter::iterator counter_iter = counter.begin();
				counter_iter != counter.end(); ++counter_iter){
			// Note: For all cases that we cover right now there is only 
			// one counter to reduce so we won't have a perf issue
			// with multiple reduces
			util::moab_tag_val_counter &val_counter = *counter_iter;
			int red_sz = static_cast<int>(val_counter.size());
			if(rank == 0){
				MPI_Reduce(MPI_IN_PLACE, &val_counter[0], red_sz,
					MPI_INT, MPI_SUM, 0, red_comm);	
			}
			else{
				MPI_Reduce(&val_counter[0], NULL, red_sz,
					MPI_INT, MPI_SUM, 0, red_comm);	
			}
		}
		switch(op){
			case PARGAL_RED_OP_DIM_AVG:
						// Sum up the data - if needed
						if(red_comm != MPI_COMM_NULL){
							int rank;
							MPI_Comm_rank(red_comm, &rank);
							for(std::vector<util::moab_tag_chunk>::iterator iter = red_chunks.begin(); iter != red_chunks.end(); ++iter){
								util::moab_tag_chunk &chunk = *iter;
								int red_sz = static_cast<int>(chunk.size());
								if(rank == 0){
									MPI_Reduce(MPI_IN_PLACE, chunk.begin(), red_sz,
										MPI_DOUBLE, MPI_SUM, 0, red_comm);
								}
								else{
									MPI_Reduce(chunks.begin(), NULL, red_sz,
										MPI_DOUBLE, MPI_SUM, 0, red_comm);
								}
							}
						}
						break;
			// FIXME: Implement the ops below
			case PARGAL_RED_OP_DIM_MAX:
			case PARGAL_RED_OP_DIM_MIN:
			default:
				throw pargal_except("Error during reduce : The op is not implemented yet",
						__FILE__, __LINE__, "Unknown");	
		}
	}

	switch(op){
		case PARGAL_RED_OP_DIM_AVG:
			{
				// Now that we have the counter and data summed up
				// - perform dim avg = sum/count
				std::vector<util::moab_tag_chunk>::iterator &var_iter = red_chunks.begin();
				std::moab_tag_red_chunk_counter::iterator &counter_iter = counter.begin();
				for(;
					(var_iter != red_chunks.end()) && (counter_iter != counter.end());
					++var_iter, ++counter_iter){
					algorithm::util::distributed_divide(*var_iter, *counter_iter,
						util::dim_traits<T>
				}
			}
			break;
		// FIXME: Implement the ops below
		case PARGAL_RED_OP_DIM_MAX:
		case PARGAL_RED_OP_DIM_MIN:
		default:
			throw pargal_except("Error during reduce : The op is not implemented yet",
					__FILE__, __LINE__, "Unknown");	
	}
}
*/
