/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * Development of this software was sponsored by the Office of Biological  *
 * and Environmental Research of the U.S. Department of Energy's Office    *
 * of Science.                                                             *
 *                                                                         *
 * Copyright 2011 UChicago Argonne, LLC.                                   *
 *                                                                         *
 * Licensed under the Apache License, Version 2.0 (the "License"); you     *
 * may not use this file except in compliance with the License.  You may   *
 * obtain a copy of the License at                                         * 
 *                                                                         *
 *   http://www.apache.org/licenses/LICENSE-2.0                            *
 *                                                                         *
 * Unless required by applicable law or agreed to in writing, software     *
 * distributed under the License is distributed on an "AS IS" BASIS,       *
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or         *
 * implied.  See the License for the specific language governing           *
 * permissions and limitations under the License.                          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef PARGAL_EXCEPTION_HPP_INCLUDED
#define PARGAL_EXCEPTION_HPP_INCLUDED

#include <string>
#include <stdexcept>

namespace pargal 
{
  class pargal_except : public std::runtime_error 
  {
  public:
    //! constructor
    explicit pargal_except(const std::string& msg, 
			   const std::string& filename, 
			   const size_t linenumber,
			   const std::string& funcname);
    
    //! destructor
    virtual ~pargal_except() throw();
   
    //! print out the error message
    void get_info();
        
  private:
    //! data member
    const std::string m_filename; 
    const size_t m_linenumber;
    const std::string m_funcname;
  };  
} // namespace pargal

#endif
